import datetime
import pandas as pd
import pandas.tseries.offsets as offsets
import time
import pyodbc
import sys

conn_str = 'Driver={Pervasive ODBC Interface};server=localhost;DBQ=VSENSOR1'
db = pyodbc.connect(conn_str)
conn_str2 = 'DSN=XXXXXXX'

db2 = pyodbc.connect(conn_str2)

sno = 0
args = sys.argv
print(args)
if 3 <= len(args):
     if args[1].isdigit():
          sno = int(args[1])
          title = args[2]
     else:
          print('Argument is not digit')
          exit()
else:
     print('Arguments are too short')
     exit()
     
# sno=9876
# title="puge"

def GetSensorInfo(sno,st_date,mean_data,max_data,min_data):
    record={
        "instime":st_date,
        "sno":int(sno),
        "xav":int(mean_data['xdata'][0]),
        "yavg":int(mean_data['ydata'][0]),
        "zavg":int(mean_data['zdata'][0]),
        "xmax":int(max_data['xdata'][0]),
        "ymax":int(max_data['ydata'][0]),
        "zmax":int(max_data['zdata'][0]),
        "xmin":int(min_data['xdata'][0]),
        "ymin":int(min_data['ydata'][0]),
        "zmin":int(min_data['zdata'][0])
    }

    return record

def get_tokei(sno,st_date,end_date,key):
    # レコード数の取得
    query = "SELECT * from data1 where sno = {0} and instime between \'{1}\' and \'{2}\'".format(sno,st_date,end_date)
    print(query)
    df = pd.read_sql(sql = query,con =  db)
    print(len(df),df.size)
    if len(df) == 0:
        print('NO DATE')
        return 'none'
    df['instime'] = pd.to_datetime(df['instime'])
    df.set_index('instime', inplace=True)

    data_range = "{0}T".format(key)
    df.resample(data_range).mean()
    average_data = df.resample(data_range).mean()
    max_data = df.resample(data_range).max()
    min_data = df.resample(data_range).min()
    complie_data = GetSensorInfo(sno,st_date,average_data,max_data,min_data)

    return complie_data

def insert_tokei(detail):
    # print('string??')
    # print(detail['ymin'])    

    sql = """INSERT
            INTO data1average(instime,
                    sno,                    
                    xavg,
                    yavg,
                    zavg,
                    xmax,
                    ymax,
                    zmax,
                    xmin,
                    ymin,
                    zmin
                    )
                VALUES (?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?,
                        ?
                         )"""
    db2.execute(sql,
                datetime.datetime.strptime(detail['instime'], '%Y-%m-%d %H:%M:%S.%f'),
                int(detail['sno']),
                int(detail['xav']),
                int(detail['yavg']),
                int(detail['zavg']),
                int(detail['xmax']),
                int(detail['ymax']),
                int(detail['zmax']),
                int(detail['xmin']),
                int(detail['ymin']),
                int(detail['ymin'])                )    

    db2.commit()


x = 1
sa=0
base_time = pd.Timestamp(datetime.datetime.now())
next_time = base_time + offsets.Minute(x-1) 

# sensor data add
flg_sakujo=False
try:
    sql = "SELECT * from data1manage where sno = {0} ".format(sno)
    # sql="select * from data1kbn where sno=23456"
    result = db2.execute(sql)
    row = result.fetchall()
    if len(row) == 0:
       flg_sakujo=True
    else:
        flg_sakujo=False
        exit()

    sql = """INSERT
            INTO data1manage(
                    sno,                    
                    title
                    )
                VALUES (?,
                        ?
                         )"""
    db2.execute(sql,
                sno,
                title
                )
    db2.commit()


except Exception as e:
        print(e)
finally:
    print('reg_done')

try:
    time.sleep(60)
    while(True):
        e = 1
        # if (sa >= x * 60):
        base_time_str=base_time.strftime('%Y-%m-%d %H:%M:00.000000')
        next_time_str=next_time.strftime('%Y-%m-%d %H:%M:59.999999')
        tokei = get_tokei(sno,base_time_str,next_time_str,x)
        if tokei !='none':
            insert_tokei(tokei)
            print('Done')

        base_time = base_time + offsets.Minute(x) 
        next_time = next_time+ offsets.Minute(x) 

        time.sleep(60)
        dt_now = datetime.datetime.now()
        # sa = dt_now - base_time
        # sa = sa.seconds

finally:
    if flg_sakujo == True:
        print('done')
        sql="delete from data1manage where sno = {0}".format(sno)
        db2.execute(sql)
        db2.commit()
    else:
        print('sno chofuku')
        

